from gstIceSrc import *

def main(args):
    
    #pipestr = "oggdemux name=decoder ! vorbisdec ! audioconvert ! alsasink"
    pipestr = "decodebin name=decoder ! audioconvert ! alsasink"
    #pipestr = "flacdec name=queue ! audioconvert ! alsasink"

    bin = gst.parse_launch(pipestr)

    icesrc = gstIceSrc('iceSource')
    icesrc.set_property('topic', 'muestra')
    #icesrc.set_property('topic-manager', 'IceStorm/TopicManager -t:tcp -h 127.0.0.1 -p 9999')
    icesrc.set_property('topic-manager','IceStorm/TopicManager -t:tcp -h mauchly.inf-cr.uclm.es -p 9999')
    icesrc.set_property('adapter', 'udp -p 5555')

    decoder = bin.get_by_name("decoder")
    
    assert (icesrc and bin and decoder)
    bin.add(icesrc)
    gst.element_link_many(icesrc, decoder)

    bin.set_state(gst.STATE_PLAYING);
    mainloop = gobject.MainLoop()

    def bus_event(bus, message):
        t = message.type
        if t == gst.MESSAGE_EOS:
            print "EOS received"
            mainloop.quit()
        elif t == gst.MESSAGE_ERROR:
            err, debug = message.parse_error()
            print "Error: %s" % err, debug
            mainloop.quit()
        elif message.type == gst.MESSAGE_STATE_CHANGED:
            pass

        
        return True
    bin.get_bus().add_watch(bus_event)
    print "run"
    mainloop.run()
    print "stop"
    bin.set_state(gst.STATE_NULL)

    return 0

if __name__ == "__main__":
    try:
        sys.exit(main(sys.argv))
    except KeyboardInterrupt:
        print "GoodBye"

